#!/bin/sh
# env
# Written in 2019 by Lucas
# CC0 1.0 Universal/Public domain - No rights reserved
#
# To the extent possible under law, the author(s) have dedicated all
# copyright and related and neighboring rights to this software to the
# public domain worldwide. This software is distributed without any
# warranty. You should have received a copy of the CC0 Public Domain
# Dedication along with this software. If not, see
# <http://creativecommons.org/publicdomain/zero/1.0/>.

if [ -f ~/.config/herbstluftwm/theme ]; then
	. ~/.config/herbstluftwm/theme
fi

show_urgent_tags() {
	mon=$1
	herbstclient tag_status "$mon" | tr "\t" "\n" | {
		s=
		while IFS= read -r line; do
			[ -n "$line" ] || continue
			tag=${line#[.:+#%!-]}

			case $line in
			!*)	focused=$(herbstclient attr tags.focus.name)
				[ "$tag" != "$focused" ] && s=$s"$line "
				;;
			esac
		done
		printf "%%{l}%%{F%s}%s%%{F-}\n" "$hlwm_color9" "$s"
	}
}

tagstatus() {
	mon=$1
	show_urgent_tags "$mon"
	herbstclient -i "tag_flags" | while read -r discard; do
		show_urgent_tags "$mon"
	done
}

if [ $# -ne 0 ]; then
	printf "Usage: %s monitor x y width height\n" "${0##*/}" >&2
	exit 1
fi

while IFS="	" read -r m x y w h; do
	left=
	center=
	right=
	{
		tagstatus "$m" &
		spoon -t &
	} | while IFS= read line; do
		case $line in
		"%{l}"*)
			left=$line
			;;
		"%{c}"*)
			center=$line
			;;
		"%{r}"*)
			right=$line
			;;
		esac
		printf "%s%s%s\n" "$left" "$center" "$right"
	done | lemonbar-xft -g "${w}x${h}+${x}+${y}" \
	    -B "$hlwm_background" -F "$hlwm_foreground" -f "$hlwm_face" &
done
herbstclient -w reload >/dev/null
kill 0
